PMEMBLK_READ(3)

NAME

pmemblk_read(), pmemblk_write() – read or write a block from a block memory pool

SYNOPSIS

    #include <libpmemblk.h>
    int pmemblk_read(PMEMblkpool *pbp, void *buf, long long blockno);
    int pmemblk_write(PMEMblkpool *pbp, const void *buf, long long blockno);

DESCRIPTION

The pmemblk_read() function reads the block with block number blockno from memory pool pbp into the buffer buf. Reading a block that has never been written by pmemblk_write() will return a block of zeroes.

The pmemblk_write() function writes a block from buf to block number blockno in the memory pool pbp. The write is atomic with respect to other reads and writes. In addition, the write cannot be torn by program failure or system crash; on recovery the block is guaranteed to contain either the old data or the new data, never a mixture of both.

RETURN VALUE

On success, the pmemblk_read() and pmemblk_write() functions return 0. On error, they return -1 and set errno appropriately.

SEE ALSO

libpmemblk(7) and <http://pmem.io>